<!--
  ~ Copyright (c) 2024 LOBA
  ~ 
  ~ Permission is hereby granted, free of charge, to any person obtaining a copy of
  ~ this software and associated documentation files (the "Software"), to deal in
  ~ the Software without restriction, including without limitation the rights to
  ~ use, copy, modify, merge, publish, distribute, sublicense, and/or sell copies of
  ~ the Software, and to permit persons to whom the Software is furnished to do so,
  ~ subject to the following conditions:
  ~ 
  ~ The above copyright notice and this permission notice shall be included in all
  ~ copies or substantial portions of the Software.
  ~ 
  ~ THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
  ~ IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY, FITNESS
  ~ FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR
  ~ COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER
  ~ IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN
  ~ CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.
  ~ 
  ~ SPDX-License-Identifier: MIT
  ~ 
  ~ Contributors:
  ~     [name] - [contribution]
-->

<template>
    <NuxtLayout name="default">
        <div class="domains-page">

            <!-- sidebar navigation teleported to template -->
            <SidebarNav :nav="navItems" :title="'Domains'" />

            <DomainsContent :domainData="domains" isPage @refresh-data="fetchDomains"></DomainsContent>

            <div class="container">
                <div class="offset-xl-1 col-xl-10 mt-160">
                    <BannersBannerCta :banners="BannerCta" />
                </div>
            </div>

        </div>
    </NuxtLayout>
</template>
<script setup lang="ts">
import type NavItemI from '~/interfaces/navItem';
import type sliderItemI from '~/interfaces/sliderItem';
import slide1 from '@/assets/images/slide1.png';

const dummyClick = () => {
    console.log('dummyClick');
}

/** DOMAINS - fetch data from api **/

const domains = ref<any>(null);

async function fetchDomains() {
  try {
    const response = await useFetchAuth('/domains');
    // Wrap the response in an object as expected by the child component
    domains.value = { domains: response || [] };
  } catch (error) {
    console.error('Error fetching domains:', error);
    domains.value = { domains: [] }; // Ensure it's an object with an array even on error
  }
}

onMounted(() => {
  fetchDomains();
});

useHead({
    title: 'Domains - DATAMITE'
});


const navItems = ref<NavItemI[]>([
    {
        label: 'All Domains',
        icon: 'list',
        action: dummyClick
    },
    {
        label: 'Recently Viewed',
        icon: 'clock',
        action: dummyClick
    },
    {
        label: 'Highlighted',
        icon: 'favourite',
        action: dummyClick
    },
    {
        label: 'Your Domains',
        icon: 'loading',
        action: dummyClick
    }
]);

const BannerCta = ref<sliderItemI[]>([
    {
        id: 1,
        title: 'Have a question or doubts?',
        text: 'Check our FAQs and Documentation',
        button_text: 'Faqs and Documentation',
        button_link: 'https://www.google.com',
        media_type: 1,
        media_url: slide1,
        template: 1,
    }
])

</script>